CSIT-212 SetupFramework scp result - logging fix
[csit.git] / bootstrap-verify-perf.sh
1 #!/bin/bash
2 # Copyright (c) 2016 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -x
16
17 # Space separated list of available testbeds, described by topology files
18 TOPOLOGIES="topologies/available/lf_testbed1-X710-X520.yaml \
19             topologies/available/lf_testbed2-X710-X520.yaml \
20             topologies/available/lf_testbed3-X710-X520.yaml"
21
22 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
23
24 VPP_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_STABLE_VER)
25 VPP_REPO_URL=$(cat ${SCRIPT_DIR}/VPP_REPO_URL)
26
27 # Reservation dir
28 RESERVATION_DIR="/tmp/reservation_dir"
29 INSTALLATION_DIR="/tmp/install_dir"
30
31 PYBOT_ARGS="-W 150 --noncritical PERFTEST --exclude SKIP_PATCH"
32
33 ARCHIVE_ARTIFACTS=(log.html output.xml report.html output_perf_data.xml)
34
35 # If we run this script from CSIT jobs we want to use stable vpp version
36 if [[ ${JOB_NAME} == csit-* ]] ;
37 then
38     mkdir vpp_download
39     cd vpp_download
40     #download vpp build from nexus and set VPP_DEBS variable
41     wget -q "${VPP_REPO_URL}/vpp/${VPP_STABLE_VER}/vpp-${VPP_STABLE_VER}.deb" || exit
42     wget -q "${VPP_REPO_URL}/vpp-dbg/${VPP_STABLE_VER}/vpp-dbg-${VPP_STABLE_VER}.deb" || exit
43     wget -q "${VPP_REPO_URL}/vpp-dev/${VPP_STABLE_VER}/vpp-dev-${VPP_STABLE_VER}.deb" || exit
44     wget -q "${VPP_REPO_URL}/vpp-dpdk-dev/${VPP_STABLE_VER}/vpp-dpdk-dev-${VPP_STABLE_VER}.deb" || exit
45     wget -q "${VPP_REPO_URL}/vpp-dpdk-dkms/${VPP_STABLE_VER}/vpp-dpdk-dkms-${VPP_STABLE_VER}.deb" || exit
46     wget -q "${VPP_REPO_URL}/vpp-lib/${VPP_STABLE_VER}/vpp-lib-${VPP_STABLE_VER}.deb" || exit
47     VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
48     cd ..
49
50 # If we run this script from vpp project we want to use local build
51 elif [[ ${JOB_NAME} == vpp-* ]] ;
52 then
53     #use local packages provided as argument list
54     # Jenkins VPP deb paths (convert to full path)
55     VPP_DEBS="$( readlink -f $@ | tr '\n' ' ' )"
56 else
57     echo "Unable to identify job type based on JOB_NAME variable: ${JOB_NAME}"
58     exit 1
59 fi
60
61 WORKING_TOPOLOGY=""
62 export PYTHONPATH=${SCRIPT_DIR}
63
64 sudo apt-get -y update
65 sudo apt-get -y install libpython2.7-dev python-virtualenv
66
67 virtualenv --system-site-packages env
68 . env/bin/activate
69
70 echo pip install
71 pip install -r requirements.txt
72
73 # We iterate over available topologies and wait until we reserve topology
74 while :; do
75     for TOPOLOGY in ${TOPOLOGIES};
76     do
77         python ${SCRIPT_DIR}/resources/tools/topo_reservation.py -t ${TOPOLOGY}
78         if [ $? -eq 0 ]; then
79             WORKING_TOPOLOGY=${TOPOLOGY}
80             echo "Reserved: ${WORKING_TOPOLOGY}"
81             break
82         fi
83     done
84
85     if [ ! -z "${WORKING_TOPOLOGY}" ]; then
86         # Exit the infinite while loop if we made a reservation
87         break
88     fi
89
90     # Wait ~3minutes before next try
91     SLEEP_TIME=$[ ( $RANDOM % 20 ) + 180 ]s
92     echo "Sleeping ${SLEEP_TIME}"
93     sleep ${SLEEP_TIME}
94 done
95
96 function cancel_all {
97     python ${SCRIPT_DIR}/resources/tools/topo_installation.py -c -d ${INSTALLATION_DIR} -t $1
98     python ${SCRIPT_DIR}/resources/tools/topo_reservation.py -c -t $1
99 }
100
101 # On script exit we cancel the reservation and installation and delete all vpp
102 # packages
103 trap "cancel_all ${WORKING_TOPOLOGY}" EXIT
104
105 python ${SCRIPT_DIR}/resources/tools/topo_installation.py -t ${WORKING_TOPOLOGY} \
106                                                        -d ${INSTALLATION_DIR} \
107                                                        -p ${VPP_DEBS}
108 if [ $? -eq 0 ]; then
109     echo "VPP Installed on hosts from: ${WORKING_TOPOLOGY}"
110 else
111     echo "Failed to copy vpp deb files to DUTs"
112     exit 1
113 fi
114
115 case "$TEST_TAG" in
116     # run specific performance tests based on jenkins job type variable
117     PERFTEST_LONG )
118         pybot ${PYBOT_ARGS} \
119               -L TRACE \
120               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
121               -s "tests.perf" \
122               -i perftest_long \
123               tests/
124         RETURN_STATUS=$(echo $?)
125         ;;
126     PERFTEST_SHORT )
127         pybot ${PYBOT_ARGS} \
128               -L TRACE \
129               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
130               -s "tests.perf" \
131               -i perftest_short \
132               tests/
133         RETURN_STATUS=$(echo $?)
134         ;;
135     PERFTEST_LONG_BRIDGE )
136         pybot ${PYBOT_ARGS} \
137               -L TRACE \
138               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
139               -s "tests.perf.Long_Bridge_Domain*" \
140               tests/
141         RETURN_STATUS=$(echo $?)
142         ;;
143     PERFTEST_LONG_IPV4 )
144         pybot ${PYBOT_ARGS} \
145               -L TRACE \
146               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
147               -s "tests.perf.Long_IPv4*" \
148               tests/
149         RETURN_STATUS=$(echo $?)
150         ;;
151     PERFTEST_LONG_IPV6 )
152         pybot ${PYBOT_ARGS} \
153               -L TRACE \
154               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
155               -s "tests.perf.Long_IPv6*" \
156               tests/
157         RETURN_STATUS=$(echo $?)
158         ;;
159     PERFTEST_LONG_XCONNECT )
160         pybot ${PYBOT_ARGS} \
161               -L TRACE \
162               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
163               -s "tests.perf.Long_Xconnect*" \
164               tests/
165         RETURN_STATUS=$(echo $?)
166         ;;
167     PERFTEST_LONG_XCONNECT_DOT1Q )
168         pybot ${PYBOT_ARGS} \
169               -L TRACE \
170               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
171               -s "tests.perf.Long_Xconnect_Dot1q*" \
172         RETURN_STATUS=$(echo $?)
173         ;;
174     PERFTEST_NDR )
175         pybot ${PYBOT_ARGS} \
176               -L TRACE \
177               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
178               -s "tests.perf" -i NDR \
179               tests/
180         RETURN_STATUS=$(echo $?)
181         ;;
182     PERFTEST_PDR )
183         pybot ${PYBOT_ARGS} \
184               -L TRACE \
185               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
186               -s "tests.perf" -i PDR \
187               tests/
188         RETURN_STATUS=$(echo $?)
189         ;;
190     * )
191         # run full performance test suite and exit on fail
192         pybot ${PYBOT_ARGS} \
193               -L TRACE \
194               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
195               -s "tests.perf" \
196               tests/
197         RETURN_STATUS=$(echo $?)
198 esac
199
200 # Pybot output post-processing
201 echo Post-processing test data...
202
203 python ${SCRIPT_DIR}/resources/tools/robot_output_parser.py \
204        -i ${SCRIPT_DIR}/output.xml \
205        -o ${SCRIPT_DIR}/output_perf_data.xml \
206        -v ${VPP_STABLE_VER}
207 if [ ! $? -eq 0 ]; then
208     echo "Parsing ${SCRIPT_DIR}/output.xml failed"
209 fi
210
211 # Archive artifacts
212 mkdir archive
213 for i in ${ARCHIVE_ARTIFACTS[@]}; do
214     cp $( readlink -f ${i} | tr '\n' ' ' ) archive/
215 done
216
217 echo Post-processing finished.
218
219 exit ${RETURN_STATUS}